soma(S,[X,Y]) :- 
	S is X + Y.

produto(P,[X,Y]) :- 
	P is X * Y.

subtracao(Sub,[X,Y]) :- 
	Sub is X - Y.

quadrado(Q,X) :- 
	Q is X * X.

unidade(1,-).

	% Com o emprego dos predicados anteriores  possvel definir outros, a saber:
ziper([ ],[ ],[ ]) :- 
	!.
ziper([X1|R1],[X2|R2],[[X1,X2]|R]) :- 
	ziper( R1, R2, R).

ap(Operac,[ ],[ ]) :- 
	!.
ap(Operac,[X|Y],[Operac X],[Operac Y]) :- 
	Predicado =.. [Operac,Operac, X, X],					
	Predicado,
	ap(Operac,Y,Operac Y).

reduz( Operac, [X,Y], resultado) :- 
	!,
	Predicado =.. [Operac,Resultado,[X,Y]],call(Predicado).
reduz(Operac, [X|Y],Resultado) :-
	reduz(Operac,Y,Y_reduzido),
	Predicado =.. [Operac,Resultado,[X,Y_reduzido]],
	call(Predicado).

cl_dir(N, [ ],[ ]) :- 
	!.
cl_dir(N,[X|R],[[X,N]|RN]) :- 
	cl_dir(N,R,RN).

cl_esq(N,[ ],[ ]) :- 
	!.
cl_esq(N,[X|R],[[N,X]|NR]) :- 
	cl_esq(N,R,NR).

varre(Op,[Y],[Y]) :- 
	!.
varre(Op,[X|Y],[Ac X,Ac Y|Resto]) :- 
	varre(Op,Y,[Ac Y|resto]),
	Predicado = .. [Op,Ac X,[X,Ac Y]],
	Predicado.
