% sortx( -Sortiert1, -Sortiert2, +Erg ) 

sortx( [] , L , L ).            % nur eine Liste -> bernehmen 
sortx( [K|R] , [] , [K|R] ) .   % nur eine Liste -> bernehmen 
sortx( [K1|R1] , [K2|R2] , [K|R] ) :-
           K1<K2 -> K=K1 , sortx( R1, [K2|R2] , R ) 
                 ;  K=K2 , sortx( [K1|R1], R2 , R ) . 

ll( [], 0 ). 
ll( [_|R] , N ) :- ll(R,N1) , N is N1+1 . 


split( L , L1, L2 ) :- ll(L,N) , N1 is N//2 , nsplit(N1, L, L1, L2). 

nsplit( 0 , L , [] , L ) . 
nsplit( N , [X|R] , [X|L1] , L2 ) :- N>0 , N1 is N-1 , 
                                     nsplit( N1 , R , L1 , L2 ) . 


mesort( L , Erg ) :- ll(L,N) , N < 2 -> Erg=L 
                                      ;  split( L, L1, L2 ) , 
                                         mesort( L1, Erg1 ) , 
                                         mesort( L2, Erg2 ) , 
                                         sortx( Erg1, Erg2 , Erg ) . 

go :- write('bitte Zahlenliste eingeben, Eingabe mit Punkt abschliessen'), nl, 
      read(L) , 
      mesort(L,Erg), 
      lout(Erg). 

lout([]) :- nl . 
lout([K|R]):- write(K), write(' '), lout(R). 

