
proibido_fazer(R,B) :- robo(R),
			     capaz_de_fazer(R,B),
			     machuca(B,H),
			     humano(H).
obrigado_a_fazer(R,B) :- robo(R),
			     capaz_de_fazer(R,B),
			     oferece_perigo(C,para,H),
			     humano(H),afasta(B,C).

deve_fazer(R,Ato) :- robo(R),
			  capaz_de_fazer(R,Ato),
			  mandou_fazer(H,R,Ato),
			  humano(H),
			  not proibido_fazer(R,Ato).

animal(H) :- humano(H).
objeto_fisico(Coisa) :- animal(Coisa).
humano(X) :- homem(X).
humano(X) :- mulher(X).
capaz_de_fazer(R,beijar(Alguem)) :- 
robo(R),
mulher(Alguem).

capaz_de_fazer(R,derrubar(Algo)) :-
			objeto_fisico(Algo),
			robo(R).
capaz_de_fazer(R,proteger(Algo)) :-
			robo(R).
machuca(derrubar(Y),Y):-humano(Y).
atleta(aurimar).
homem(berengario).
homem(joaquim).
homem(luck).
mulher(esmeralda).
mulher(nadia).
pai(berengario,esmeralda).
treinou(reinaldo,aurimar).
ama(esmeralda,joaquim).
ama(joaquim,esmeralda).
robo(cesar).
mandou_fazer(joaquim,cesar,proteger(nadia)).
mandou_fazer(berengario,cesar,derrubar(nadia)).
oferece_perigo(dartvader,para,H):-humano(H),ataca(dartvader,H).
ataca(dartvader,esmeralda).
animal(dartvader).
afasta(derrubar(dartvader),dartvader).
